using System.Collections.Generic;

using LiteDB;

using skydiveLogs_api.Domain;
using skydiveLogs_api.DomainService.Repositories;
using skydiveLogs_api.Infrastructure.Interfaces;


namespace skydiveLogs_api.Infrastructure
{
    public class JumpRepository : IJumpRepository
    {
        public JumpRepository(IDataProvider dataProvider)
        {
            _dataProvider = dataProvider;
            _col = _dataProvider.CollOfJump;
        }

        public IEnumerable<Jump> GetAll(User user)
        {
            return _col.Include(x => x.Aircraft)
                       .Include(x => x.DropZone)
                       .Include(x => x.Gear)
                       .Include(x => x.JumpType)
                       .Include(x => x.User)
                       .Query()
                       .Where(j => j.User.Id == user.Id)
                       .ToList();
        }

        public Jump GetById(int id)
        {
            return _col.FindById(new BsonValue(id));
        }

        public bool Add(Jump newJump)
        {
            var result = true;

            try
            {
                _col.Insert(newJump);
            }
            catch
            {
                result = false;
            }

            return result;
        }

        public bool Update(Jump updatedJump)
        {
            throw new System.NotImplementedException();
        }

        public IEnumerable<Jump> GetAll()
        {
            throw new System.NotImplementedException();
        }

        private readonly IDataProvider _dataProvider;

        private readonly ILiteCollection<Jump> _col;
    }
}
